# coding: utf-8

"""
    Vectorize API (Beta)

    API documentation for Vectorize services

    The version of the OpenAPI document: 0.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class PipelineListSummary(BaseModel):
    """
    PipelineListSummary
    """ # noqa: E501
    id: StrictStr
    name: StrictStr
    document_count: Union[StrictFloat, StrictInt] = Field(alias="documentCount")
    source_connector_auth_ids: List[StrictStr] = Field(alias="sourceConnectorAuthIds")
    destination_connector_auth_ids: List[StrictStr] = Field(alias="destinationConnectorAuthIds")
    ai_platform_auth_ids: List[StrictStr] = Field(alias="aiPlatformAuthIds")
    source_connector_types: List[StrictStr] = Field(alias="sourceConnectorTypes")
    destination_connector_types: List[StrictStr] = Field(alias="destinationConnectorTypes")
    ai_platform_types: List[StrictStr] = Field(alias="aiPlatformTypes")
    created_at: Optional[StrictStr] = Field(alias="createdAt")
    created_by: StrictStr = Field(alias="createdBy")
    status: StrictStr
    config_doc: Optional[Dict[str, Any]] = Field(default=None, alias="configDoc")
    __properties: ClassVar[List[str]] = ["id", "name", "documentCount", "sourceConnectorAuthIds", "destinationConnectorAuthIds", "aiPlatformAuthIds", "sourceConnectorTypes", "destinationConnectorTypes", "aiPlatformTypes", "createdAt", "createdBy", "status", "configDoc"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PipelineListSummary from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if created_at (nullable) is None
        # and model_fields_set contains the field
        if self.created_at is None and "created_at" in self.model_fields_set:
            _dict['createdAt'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PipelineListSummary from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "documentCount": obj.get("documentCount"),
            "sourceConnectorAuthIds": obj.get("sourceConnectorAuthIds"),
            "destinationConnectorAuthIds": obj.get("destinationConnectorAuthIds"),
            "aiPlatformAuthIds": obj.get("aiPlatformAuthIds"),
            "sourceConnectorTypes": obj.get("sourceConnectorTypes"),
            "destinationConnectorTypes": obj.get("destinationConnectorTypes"),
            "aiPlatformTypes": obj.get("aiPlatformTypes"),
            "createdAt": obj.get("createdAt"),
            "createdBy": obj.get("createdBy"),
            "status": obj.get("status"),
            "configDoc": obj.get("configDoc")
        })
        return _obj


